package com.njcn.rdms.module.system.dal.mysql.file;

import com.njcn.rdms.framework.common.pojo.PageResult;
import com.njcn.rdms.framework.mybatis.core.mapper.BaseMapperX;
import com.njcn.rdms.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.njcn.rdms.module.system.controller.admin.file.vo.file.FilePageReqVO;
import com.njcn.rdms.module.system.dal.dataobject.file.FileDO;
import org.apache.ibatis.annotations.Mapper;

import java.util.Objects;

import static com.njcn.rdms.framework.common.util.http.HttpUtils.removeUrlQuery;

/**
 * 文件操作 Mapper
 *
 * @author hongawen
 */
@Mapper
public interface FileMapper extends BaseMapperX<FileDO> {

    default PageResult<FileDO> selectPage(FilePageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<FileDO>()
                .likeIfPresent(FileDO::getPath, reqVO.getPath())
                .likeIfPresent(FileDO::getType, reqVO.getType())
                .betweenIfPresent(FileDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(FileDO::getId));
    }

    default FileDO selectByUrl(String url) {
        FileDO file = selectFirstOne(FileDO::getUrl, url);
        String urlWithoutQuery = removeUrlQuery(url);
        if (file == null && !Objects.equals(urlWithoutQuery, url)) {
            file = selectOne(new LambdaQueryWrapperX<FileDO>()
                    .likeRight(FileDO::getUrl, urlWithoutQuery)
                    .last("LIMIT 1"));
        }
        if (file == null && !Objects.equals(urlWithoutQuery, url)) {
            file = selectFirstOne(FileDO::getUrl, urlWithoutQuery);
        }
        return file;
    }

}
